#
# Spec file for prolinga-validate
#
Summary: 	Library that parses, validates and transforms ProLinga 4GL logic into an XML document.
Name: 		prolinga-validate
Version: 	0.0.2
Release: 	1.fc12.xobas
License: 	GPL
Group:		System Environment/Libraries
Source: 	http://download.prolinga.org/main/sources/%{name}-%{version}.tar.bz2
URL: 		http://www.xobas.com/
Vendor: 	Xobas Software
Packager: 	Bas Driessen <bas.driessen@xobas.com>
BuildRoot: 	%{_tmppath}/%{name}-%{version}-root
Requires: 	libxml2 >= 2.6.5
Requires: 	prolinga-soap >= 0.0.2

%description
The ProLinga-Validate project is a project that
focuses on the development of a library that 
parses, validates and transforms ProLinga 4GL logic
into an XML document. This result XML document,
called a RunControl, is used at run-time by prolinga-run.

%package server
Summary:	Daemon binary providing Web Service functionality.
Group:		System Environment/Libraries
Requires:	%name = %{version}
Requires:	libxml2 >= 2.6.5
Requires: 	prolinga-soap >= 0.0.2

%description server
This package contains the daemon binary providing
network access.

%package nonet
Summary:	Nonet validate daemon for standalone linkage.
Group:		System Environment/Libraries
Requires:	libxml2 >= 2.6.5
Requires:	%name = %{version}
Requires: 	prolinga-repository >= 0.0.2

%description nonet
This package contains the library for direct interface
to ProLinga-Repository. The daemon is not installed as
a service by default, to prevent conflict with the
default validate package. Also it is unlikely to 
use the daemon in combination with a link to the
repository.

%package server-nonet
Summary:	Libraries for applications using prolinga-validate nonet.
Group:		System Environment/Libraries
Requires:	%name = %{version}
Requires:	libxml2 >= 2.6.5
Requires:	prolinga-repository >= 0.0.2

%description server-nonet
This package contains the libraries for applications
using prolinga-validate. It contains a direct link to
the repository rather than using SOAP.

%package devel
Summary:	Development libraries and header files for prolinga-validate.
Group:		Development/Libraries
Requires:	%name = %{version}
Requires:	%name-nonet = %{version}
Requires: 	prolinga-repository >= 0.0.2
Requires: 	prolinga-repository-devel >= 0.0.2
Requires: 	prolinga-soap >= 0.0.2
Requires: 	prolinga-soap-devel >= 0.0.2
Requires: 	libxml2 >= 2.6.5
Requires: 	libxml2-devel >= 2.6.5

%description devel
This package contains the header files and libraries needed to write
or compile programs that use prolinga-validate.

%prep
%setup -q

%build
%configure \
	--enable-local-repository \
	--prefix=%{_prefix} \
	--libdir=%{_libdir}
make
#make html

%install
rm -rf %{buildroot}
%makeinstall

# Put startup script in the right place.
mkdir -p %{buildroot}%{_sysconfdir}/rc.d/init.d/
install -m 755 %{_builddir}/%{name}-%{version}/prolinga/prolingavald.init %{buildroot}%{_sysconfdir}/rc.d/init.d/prolingavald

# Set hostname to localhost in config file.
sed -e "s?`(hostname || uname -n) 2>/dev/null | sed 1q`<?localhost<?g" < %{buildroot}%{_sysconfdir}/prolingavalcfg.xml > %{_tmppath}/prolingavalcfg.tmp
mv %{_tmppath}/prolingavalcfg.tmp %{buildroot}%{_sysconfdir}/prolingavalcfg.xml

# Set Repository system path
sed -e "s?<SystemPath>.*?<SystemPath>%{_localstatedir}/lib/prolinga/system</SystemPath>?g" < %{buildroot}%{_sysconfdir}/prolingavalcfg.xml > %{_tmppath}/prolingavalcfg.tmp
mv %{_tmppath}/prolingavalcfg.tmp %{buildroot}%{_sysconfdir}/prolingavalcfg.xml

%clean
rm -rf %{buildroot}

%post
# update library links.
/sbin/ldconfig

# Change hostname from localhost to real hostname in config file.
sed -e "s?localhost<?`(hostname || uname -n) 2>/dev/null | sed 1q`<?g" < %{_sysconfdir}/prolingavalcfg.xml > %{_tmppath}/prolingavalcfg.tmp
mv %{_tmppath}/prolingavalcfg.tmp %{_sysconfdir}/prolingavalcfg.xml

# Set correct permissions.
chmod 644 %{_sysconfdir}/prolingavalcfg.xml

%post server
# Add prolingavald as service
/sbin/chkconfig --add prolingavald

%preun server
if [ "$1" -eq 0 ]; then
    /sbin/service prolingavald stop > /dev/null 2>&1
    /sbin/chkconfig --del prolingavald
fi
exit 0

%postun server
if [ "$1" -ge 1 ]; then
    /sbin/service prolingavald condrestart > /dev/null 2>&1
fi
exit 0

%postun
# update library links.
/sbin/ldconfig

%files
%defattr(-,root,root)
%doc AUTHORS COPYING ChangeLog README NEWS
%doc doc/html
%{_bindir}/prolingavalclient
%{_bindir}/prolingavalexec
%{_bindir}/prolingavalparser
%{_libdir}/libprolingavalidate-*.so.*
%{_libdir}/libprolingavalidate_nonet-*.so.*
%{_datadir}/prolinga/*
%{_sysconfdir}/prolingavalcfg.xml

%files server
%defattr(-,root,root)
%{_bindir}/prolingavald
%config /etc/rc.d/init.d/*

%files nonet
%defattr(-,root,root)
%{_bindir}/prolingavalnnexec
%{_bindir}/prolingavalnnparser

%files server-nonet
%defattr(-,root,root)
%{_bindir}/prolingavalnnd

%files devel
%defattr(-, root, root)
%doc doc/*.xml doc/*.xsl doc/*.txt
%{_includedir}/prolinga
%{_libdir}/*.a
%{_libdir}/*.la
%{_libdir}/*.so
%{_libdir}/pkgconfig/*

%changelog
* Sun Apr 11 2010 Bas Driessen <bas.driessen@xobas.com> 0.0.2-1.fc12
- Build for Fedora 12.

* Thu Aug 27 2009 Bas Driessen <bas.driessen@xobas.com> 0.0.2-1.fc11
- Build for Fedora 11.
- New upstream release.
- Move SystemPath to new location of localstatedir/lib.

* Tue May 20 2008 Bas Driessen <bas.driessen@xobas.com> 0.0.1-1.fc9
- Build for Fedora 9.

* Sat Mar 22 2008 Bas Driessen <bas.driessen@xobas.com> 0.0.1-1.fc8
- Initial spec file.

